package sun.net;

import java.io.IOException;
import java.io.OutputStream;
import java.io.BufferedOutputStream;

public class TelnetOutputStream extends BufferedOutputStream
{
    boolean stickyCRLF;
    boolean seenCR;
    public boolean binaryMode;
    
    public TelnetOutputStream(OutputStream out, boolean binaryMode) {
        super(out);
        this.stickyCRLF = false;
        this.seenCR = false;
        this.binaryMode = false;
        this.binaryMode = binaryMode;
    }
    
    public void setStickyCRLF(boolean stickyCRLF) {
        this.stickyCRLF = stickyCRLF;
    }
    
    @Override
    public void write(int b) throws IOException {
        if (this.binaryMode) {
            super.write(b);
            return;
        }
        if (this.seenCR) {
            if (b != 10) {
                super.write(0);
            }
            super.write(b);
            if (b != 13) {
                this.seenCR = false;
            }
        }
        else {
            if (b == 10) {
                super.write(13);
                super.write(10);
                return;
            }
            if (b == 13) {
                if (this.stickyCRLF) {
                    this.seenCR = true;
                }
                else {
                    super.write(13);
                    b = 0;
                }
            }
            super.write(b);
        }
        return;
    }
    
    @Override
    public void write(byte[] b, int off, int len) throws IOException {
        if (this.binaryMode) {
            super.write(b, off, len);
            return;
        }
        while (--len >= 0) {
            this.write((int)b[off++]);
        }
        return;
    }
}
